(** Time-stamp: <modified the 18/12/2007 (at 14:55) by Erwan Jahier> *)

open Lxm
open Errors
open SyntaxTree
open CompiledData
open EvalConst 

exception EvalType_error of string

(*---------------------------------------------------------------------
eval_type
-----------------------------------------------------------------------
Rle :

Entres : id_solver + type_exp

Sorties : type_eff

Effets de bord :
	Compile_error
----------------------------------------------------------------------*)

let rec f
    (env : id_solver)
    (texp : type_exp)
    = (
      try (
	match texp.it with 
     	    Bool_type_exp -> Bool_type_eff
	  | Int_type_exp  -> Int_type_eff
	  | Real_type_exp -> Real_type_eff
	  | Named_type_exp s -> (
	      env.id2type s texp.src 
	    )
	  | Array_type_exp (elt_texp, szexp) -> (
	      let elt_teff = f env elt_texp in
		try (
		  let sz = EvalConst.eval_array_size env szexp in
		    Array_type_eff ( elt_teff, sz)
		) with EvalArray_error msg -> raise(EvalType_error msg)
	    )
      ) with EvalType_error msg -> (
	raise (Compile_error(texp.src, "can't eval type: "^msg))	
      )
    )
