(** Time-stamp: <modified the 30/01/2008 (at 16:18) by Erwan Jahier> *)

(*
Un module au dessus de lexer et parser
pour viter les dpendances boucles
*)


type t


val str : t -> string
val id : t -> Ident.t
val pack_name : t -> Ident.pack_name
val line : t -> int 
val cstart : t -> int
val cend : t -> int


(**-----------------------------*)
(** Interface avec lexer/parser *)
(**-----------------------------*)

(** Le lexer doit imprativement : *)
(** - utiliser make pour rendre un lexeme au parser *)
val make : Lexing.lexbuf -> t

(** - appeler new_line sur chaque \n pour permettre
      la numrotation ligne/colonnes *)
val new_line : Lexing.lexbuf -> unit

(**-------------------------------*)
(** Interface avec le compilateur *)
(**-------------------------------*)

(** Atache une info source  n'importe quoi *)
type 'a srcflaged = { src : t ; it  : 'a }
val flagit : 'a -> t -> 'a srcflaged

(** Un lexeme bibon au cas o ... *)
val dummy : t

(** Renvoie le dernier lexme cr (et trait),
    Utile pour situer les erreurs de syntaxe *)
val last_made : unit -> t

(** Affichage standard pour erreur/warning *)

(** style : 'machin' (line:10, col:3 to 7) *)
val details : t -> string

(** style : line:10, col:3 to 7 *)
val position : t -> string

